# -*- coding: utf-8 -*-

from accounts.models import User, Group
from datetime import datetime
from django.conf import settings


def getPromo():
    # renvoie le tableau des <i>A
    now = datetime.now()
    year = now.year
    if now.month <= 9:
        year -= 1
    return [year + 4, year + 3, year + 2, year + 1, year]


test_user = {
    "testone": {
        "email": "testone@bde.enseeiht.fr",
        "first_name": "Test",
        "last_name": "One",
        "AE": True,
        "Promo": 1,
        "year": getPromo()[1],
        "ecole": "n7",
        "bureau": ["test-n7", "test-inp"],
        "membre": ["test-n7", "test-inp"],
        "admin": False,
    },
    "testwo": {
        "email": "testwo@bde.enseeiht.fr",
        "first_name": "Tes",
        "last_name": "Two",
        "AE": False,
        "Promo": 2,
        "year": getPromo()[2],
        "ecole": "n7",
        "bureau": ["test-inp"],
        "membre": ["test-inp"],
        "admin": False,
    },
    "testthree": {
        "email": "testthree@bde.enseeiht.fr",
        "first_name": "Test",
        "last_name": "Three",
        "AE": True,
        "Promo": 3,
        "year": getPromo()[3],
        "ecole": "n7",
        "bureau": ["test-n7", "test-inp"],
        "membre": ["test-n7", "test-inp"],
        "admin": False,
    },
    "testfour": {
        "email": "testfour@bde.enseeiht.fr",
        "first_name": "Test",
        "last_name": "Four",
        "AE": True,
        "Promo": 4,
        "year": getPromo()[4],
        "ecole": "n7",
        "bureau": [],
        "membre": [],
        "admin": False,
    },
    "testensat": {
        "email": "testensat@bde.ensat.fr",
        "first_name": "Test",
        "last_name": "Ensat",
        "AE": True,
        "Promo": 1,
        "year": getPromo()[1],
        "ecole": "ensat",
        "bureau": ["test-inp"],
        "membre": ["test-inp"],
        "admin": False,
    },
    "testasept": {
        "email": "testasept@bde.ensiacet.fr",
        "first_name": "Test",
        "last_name": "Asept",
        "AE": True,
        "Promo": 3,
        "year": getPromo()[3],
        "ecole": "a7",
        "bureau": [],
        "membre": ["test-inp"],
        "admin": False,
    },
}

group_test = {
    "test-inp": {
        "displayName": "test",
    },
    "test-n7": {
        "displayName": "test",
    },
}


def createLdapUser(login):
    assert login in test_user
    if User.objects.filter(login_inp_net=login):
        return
    for grp in test_user[login]["membre"] + test_user[login]["bureau"]:
        if not Group.objects.filter(cn=grp).exists():
            Group(cn=grp, displayName=group_test[grp]["displayName"]).save()
    user = User.objects.create_user(
        test_user[login]["email"], first_name=test_user[login]["first_name"], last_name=test_user[login]["last_name"]
    )
    user.promo = test_user[login]["year"]
    user.ecole = test_user[login]["ecole"]
    user.is_adherent_ae = test_user[login]["AE"]
    user.login_inp_net = login
    user.is_active = True
    user.is_superuser = test_user[login]["admin"]
    user.save()
    for grp in test_user[login]["membre"]:
        groupe = Group.objects.get(cn=grp)
        user.groupes.add(groupe)
    for grp in test_user[login]["bureau"]:
        groupe = Group.objects.get(cn=grp)
        user.managed_clubs.add(groupe)
    user.save()
    return user


def createLdapUsers():
    for user in test_user:
        createLdapUser(user)


def createExteUser(login, password, prenom, nom):
    user = User.objects.create_user(login, password, prenom, nom)
    user.is_active = True
    user.save()
    return user


def loginUser(client, name):
    if User.objects.filter(login_inp_net=name).exists():
        client.force_login(User.objects.get(login_inp_net=name), backend=settings.AUTHENTICATION_BACKENDS[0])
        return True
    if User.objects.filter(email=name).exists():
        client.force_login(User.objects.get(email=name), backend=settings.AUTHENTICATION_BACKENDS[0])
        return True
    return False
